(function ($) {
        $.fn.tblToExcel = function (options) {
			var link = options.anchor;
			var title = options.title;

            var tableToExcel = (function () {
                var i = 0;
                var uri = 'data:application/vnd.ms-excel;base64,',
                    template = '<html xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:x="urn:schemas-microsoft-com:office:excel" xmlns="http://www.w3.org/TR/REC-html40"><head><!--[if gte mso 9]><xml><x:ExcelWorkbook><x:ExcelWorksheets><x:ExcelWorksheet><x:Name>{worksheet}</x:Name><x:WorksheetOptions><x:DisplayGridlines/></x:WorksheetOptions></x:ExcelWorksheet></x:ExcelWorksheets></x:ExcelWorkbook></xml><![endif]--></head><body><table>{table}</table></body></html>'
                    , base64 = function (s) {
                        return window.btoa(unescape(encodeURIComponent(s)))
                    }
                    , format = function (s, c) {
                        return s.replace(/{(\w+)}/g, function (m, p) {
                            return c[p];
                        })
                    };
                return function (table, name) {
                    if (!table.nodeType) table
                    var ctx = {worksheet: name || 'Worksheet', table: table.innerHTML}
                    var xl = uri + base64(format(template, ctx));

					if (link) return xl;
                    else window.location.href = xl;
                }
            })();

            return this.each(function () {
				var ret = tableToExcel(this, title);
				if (link) {
					$(link).prop("download", title + ".xls");
					$(link).prop("href", ret);
				}
            });
        }

    }(jQuery));
